#include "StdAfx.h"
#include "Game.h"

#include "resource.h"
#include <conio.h>
#include <cmath>

#include <gdiplus.h>
using namespace Gdiplus;

#pragma comment(lib, "gdiplus.lib")

// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
// | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
// V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V
//
// The following line is needed to call the TransparentBlt function (and AlphaBlend).
//	Otherwise you will get a linker error.
#pragma comment(lib, "Msimg32.lib")
//
// ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^
// | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

// Macro used to detect the state of a button.
#define KEYDOWN(vkcode) (GetAsyncKeyState(vkcode) & 0x8000 ? true : false)



Game::Game(void)
{
	bRunning = TRUE;

	// Zero out the frames per second variables:
	dwFrames = 0;
	dwCurrentTime = 0;
	dwLastUpdateTime = 0;
	dwElapsedTime = 0;
	szFPS[0] = '\0';

}

Game::~Game(void)
{
}
//
//void Game::TitleScreen(void)
//{
//
//		
//}

void Game::Startup(void)
{
//TODO: Create Back Buffer


	// Get the Display DC.
	hdcDisplay = GetDC(hWnd);

	// Create a Memory DC.
	hdcMemory = CreateCompatibleDC(hdcDisplay);

	// Create a Back Buffer Bitmap.
	hbmBackBuffer = CreateCompatibleBitmap(hdcDisplay,
		GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));

	// Select the Back Buffer Bitmap into the Memory DC & store the Default Bitmap.
	hbmOld = (HBITMAP)SelectObject(hdcMemory, hbmBackBuffer);


//TODO: Load Bitmaps/Brushes/Pens/Fonts


	// Get the application instance. (Needed when loading from resource script.)
	HINSTANCE hInst = GetModuleHandle(NULL);

	//LOAD SOUNDS/////////////////////////////////////////////
result = FMOD::System_Create(&system);		// Create the main system object.
if (result != FMOD_OK)
{
    printf("FMOD error! (%d) %s\n", result, FMOD_ErrorString(result));
    exit(-1);
}

result = system->init(100, FMOD_INIT_NORMAL, 0);	// Initialize FMOD.
if (result != FMOD_OK)
{
    printf("FMOD error! (%d) %s\n", result, FMOD_ErrorString(result));
    exit(-1);
}

result = system->createSound("gunShot.mp3", FMOD_DEFAULT, 0, &gunShot);		// FMOD_DEFAULT uses the defaults.  These are the same as FMOD_LOOP_OFF | FMOD_2D | FMOD_HARDWARE.
result = system->createSound("explosion.mp3", FMOD_DEFAULT, 0, &explosion);		// FMOD_DEFAULT uses the defaults.  These are the same as FMOD_LOOP_OFF | FMOD_2D | FMOD_HARDWARE.
result = system->createSound("message.mp3", FMOD_DEFAULT, 0, &message);		// FMOD_DEFAULT uses the defaults.  These are the same as FMOD_LOOP_OFF | FMOD_2D | FMOD_HARDWARE.
result = system->createSound("number.mp3", FMOD_DEFAULT, 0, &number);		// FMOD_DEFAULT uses the defaults.  These are the same as FMOD_LOOP_OFF | FMOD_2D | FMOD_HARDWARE.
result = system->createSound("bgMusic1.mp3", FMOD_LOOP_NORMAL | FMOD_2D | FMOD_HARDWARE, 0, &bgMusic);		// FMOD_DEFAULT uses the defaults.  These are the same as FMOD_LOOP_OFF | FMOD_2D | FMOD_HARDWARE.
result = system->createSound("cheering.mp3", FMOD_DEFAULT, 0, &win);		// FMOD_DEFAULT uses the defaults.  These are the same as FMOD_LOOP_OFF | FMOD_2D | FMOD_HARDWARE.
result = system->createSound("hit.mp3", FMOD_DEFAULT, 0, &hit);		// FMOD_DEFAULT uses the defaults.  These are the same as FMOD_LOOP_OFF | FMOD_2D | FMOD_HARDWARE.
result = system->createSound("TitleMusic.mp3", FMOD_LOOP_NORMAL | FMOD_2D | FMOD_HARDWARE, 0, &titleMusic);		// FMOD_DEFAULT uses the defaults.  These are the same as FMOD_LOOP_OFF | FMOD_2D | FMOD_HARDWARE.
result = system->createSound("menuBlip.mp3", FMOD_DEFAULT, 0, &menuBlip);		// FMOD_DEFAULT uses the defaults.  These are the same as FMOD_LOOP_OFF | FMOD_2D | FMOD_HARDWARE.


//////////////////////////////////////////////////////////////////

	// * * * * * * * * * * * * * * * * * * * * * 
	// Load TitleScreen.bmp
	// * * * * * * * * * * * * * * * * * * * * * 
	hbmTitle = (HBITMAP)LoadImage(hInst, _T("TitleScreenMenu.bmp") /*MAKEINTRESOURCE(IDB_NEBULA)*/,
		IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
	if(hbmTitle == NULL)
	{
		MessageBox(0, _T("Could Not Load TitleScreen.bmp"), 0, 0);
	}

	hdcTitle = CreateCompatibleDC(hdcDisplay);

	hbmTitleOld = (HBITMAP)SelectObject(hdcTitle, hbmTitle);

	GetObject(hbmTitle, sizeof(BITMAP), &bmTitleInfo);

	// * * * * * * * * * * * * * * * * * * * * * 
	// Load TitleScreenMap.bmp
	// * * * * * * * * * * * * * * * * * * * * * 
	hbmTitleMap = (HBITMAP)LoadImage(hInst, _T("TitleScreenMap.bmp") /*MAKEINTRESOURCE(IDB_NEBULA)*/,
		IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
	if(hbmTitleMap == NULL)
	{
		MessageBox(0, _T("Could Not Load TitleScreenMap.bmp"), 0, 0);
	}

	hdcTitleMap = CreateCompatibleDC(hdcDisplay);

	hbmTitleMapOld = (HBITMAP)SelectObject(hdcTitleMap, hbmTitleMap);

	GetObject(hbmTitleMap, sizeof(BITMAP), &bmTitleMapInfo);
	

	// * * * * * * * * * * * * * * * * * * * * * 
	// Load Numbers.bmp
	// * * * * * * * * * * * * * * * * * * * * * 
	hbmScore = (HBITMAP)LoadImage(hInst, _T("Numbers.bmp") /*MAKEINTRESOURCE(IDB_NEBULA)*/,
		IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
	if(hbmScore == NULL)
	{
		MessageBox(0, _T("Could Not Load Numbers.bmp"), 0, 0);
	}

	hdcScore = CreateCompatibleDC(hdcDisplay);

	hbmScoreOld = (HBITMAP)SelectObject(hdcScore, hbmScore);

	GetObject(hbmScore, sizeof(BITMAP), &bmScoreInfo);

	// * * * * * * * * * * * * * * * * * * * * * 
	// Load bomb.bmp
	// * * * * * * * * * * * * * * * * * * * * * 
	hbmBomb = (HBITMAP)LoadImage(hInst, _T("bomb.bmp") /*MAKEINTRESOURCE(IDB_NEBULA)*/,
		IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
	if(hbmBomb == NULL)
	{
		MessageBox(0, _T("Could Not Load bomb.bmp"), 0, 0);
	}

	hdcBomb = CreateCompatibleDC(hdcDisplay);

	hbmBombOld = (HBITMAP)SelectObject(hdcBomb, hbmBomb);

	GetObject(hbmBomb, sizeof(BITMAP), &bmBombInfo);


	// * * * * * * * * * * * * * * * * * * * * * 
	// Load Player1.bmp (from file)
	// * * * * * * * * * * * * * * * * * * * * * 
	hbmPlayer1 = (HBITMAP)LoadImage(NULL, _T("Player1.bmp"),
		IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
	if(hbmPlayer1 == NULL)
	{
		MessageBox(0, _T("Could Not load Player1.bmp"), 0, 0);
	}

	hdcPlayer1 = CreateCompatibleDC(hdcDisplay);

	hbmPlayer1Old = (HBITMAP)SelectObject(hdcPlayer1, hbmPlayer1);

	GetObject(hbmPlayer1, sizeof(BITMAP), &bmPlayer1Info);


	//// * * * * * * * * * * * * * * * * * * * * * 
	//// Load player1HUD.bmp (from file)
	//// * * * * * * * * * * * * * * * * * * * * * 
	hbmPlayer1HUD = (HBITMAP)LoadImage(NULL, _T("player1HUD.bmp"),
		IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
	if(hbmPlayer1HUD == NULL)
	{
		MessageBox(0, _T("Could Not load player1HUD.bmp"), 0, 0);
	}

	hdcPlayer1HUD = CreateCompatibleDC(hdcDisplay);

	hbmPlayer1HUDOld = (HBITMAP)SelectObject(hdcPlayer1HUD, hbmPlayer1HUD);

	GetObject(hbmPlayer1HUD, sizeof(BITMAP), &bmPlayer1HUDInfo);


	// * * * * * * * * * * * * * * * * * * * * * 
	// Load Player2.bmp (from file)
	// * * * * * * * * * * * * * * * * * * * * * 
	hbmPlayer2 = (HBITMAP)LoadImage(NULL, _T("Player2.bmp"),
		IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
	if(hbmPlayer2 == NULL)
	{
		MessageBox(0, _T("Could Not load Player2.bmp"), 0, 0);
	}

	hdcPlayer2 = CreateCompatibleDC(hdcDisplay);

	hbmPlayer2Old = (HBITMAP)SelectObject(hdcPlayer2, hbmPlayer2);

	GetObject(hbmPlayer2, sizeof(BITMAP), &bmPlayer2Info);


	//// * * * * * * * * * * * * * * * * * * * * * 
	//// Load player1HUD.bmp (from file)
	//// * * * * * * * * * * * * * * * * * * * * * 
	hbmPlayer2HUD = (HBITMAP)LoadImage(NULL, _T("player2HUD.bmp"),
		IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
	if(hbmPlayer2HUD == NULL)
	{
		MessageBox(0, _T("Could Not load player2HUD.bmp"), 0, 0);
	}

	hdcPlayer2HUD = CreateCompatibleDC(hdcDisplay);

	hbmPlayer2HUDOld = (HBITMAP)SelectObject(hdcPlayer2HUD, hbmPlayer2HUD);

	GetObject(hbmPlayer2HUD, sizeof(BITMAP), &bmPlayer2HUDInfo);


	//// * * * * * * * * * * * * * * * * * * * * * 
	//// Load target.bmp (from file)
	//// * * * * * * * * * * * * * * * * * * * * * 
	hbmPlayer1Target = (HBITMAP)LoadImage(NULL, _T("target.bmp"),
		IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
	if(hbmPlayer1Target == NULL)
	{
		MessageBox(0, _T("Could Not load target.bmp"), 0, 0);
	}

	hdcPlayer1Target = CreateCompatibleDC(hdcDisplay);

	hbmPlayer1TargetOld = (HBITMAP)SelectObject(hdcPlayer1Target, hbmPlayer1Target);

	GetObject(hbmPlayer1Target, sizeof(BITMAP), &bmPlayer1TargetInfo);


	//// * * * * * * * * * * * * * * * * * * * * * 
	//// Load target.bmp (from file)
	//// * * * * * * * * * * * * * * * * * * * * * 
	hbmPlayer2Target = hbmPlayer1Target;

	hdcPlayer2Target = hdcPlayer1Target;

	hbmPlayer2TargetOld = hbmPlayer1TargetOld;

	GetObject(hbmPlayer2Target, sizeof(BITMAP), &bmPlayer2TargetInfo);



	//// * * * * * * * * * * * * * * * * * * * * * 
	//// Load targetimage.bmp (from file)
	//// * * * * * * * * * * * * * * * * * * * * * 
	hbmTargetArrow = (HBITMAP)LoadImage(NULL, _T("targetimage.bmp"),
		IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
	if(hbmTargetArrow == NULL)
	{
		MessageBox(0, _T("Could Not load target.bmp"), 0, 0);
	}

	hdcTargetArrow = CreateCompatibleDC(hdcDisplay);

	hbmTargetArrowOld = (HBITMAP)SelectObject(hdcTargetArrow, hbmTargetArrow);

	GetObject(hbmTargetArrow, sizeof(BITMAP), &bmTargetArrowInfo);



	// * * * * * * * * * * * * * * * * * * * * * 
	// Load Explosion.bmp (from file)
	// * * * * * * * * * * * * * * * * * * * * * 
	hbmExplosion = (HBITMAP)LoadImage(NULL, _T("Explosion.bmp"),
		IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
	if(hbmExplosion == NULL)
	{
		MessageBox(0, _T("Could Not load Explosion.bmp"), 0, 0);
	}

	hdcExplosion = CreateCompatibleDC(hdcDisplay);

	hbmExplosionOld = (HBITMAP)SelectObject(hdcExplosion, hbmExplosion);

	GetObject(hbmExplosion, sizeof(BITMAP), &bmExplosionInfo);



	//PLAY TITLE MUSIC
	result = system->playSound( FMOD_CHANNEL_REUSE, titleMusic, false, &titleChannel);

	int startx = 180;
	int starty = 280;

	MapSelection = 0;

	bool NextScreen = false;

	Graphics graphics(hdcMemory);

	SolidBrush br(Color(0, 255, 0, 0));
	Pen pen(Color(255, 255, 0, 0), 10);

	static DWORD dwTime = GetTickCount();

	while(!KEYDOWN('Q'))
	{
		//TODO: Clear Back Buffer
	FillRect(hdcMemory,&rClient,(HBRUSH)GetStockObject(BLACK_BRUSH));

	//Get dimensions of client
	GetClientRect(hWnd,&rClient);

		BitBlt(hdcMemory, 0, 0, bmTitleInfo.bmWidth, bmTitleInfo.bmHeight,
		hdcTitle, 0, 0, SRCCOPY);

		system->update();

	
		//DISPLAY MENU
		if(GetTickCount() - dwTime > 100) //timeGetTime(), QueryPerformanceCounter
		{
			if(!NextScreen)
			{
				if(KEYDOWN(VK_DOWN))
				{
						result = system->playSound( FMOD_CHANNEL_FREE, menuBlip, false, &titleChannel);

					//starty += 100;
					if(selection < 3)
						selection++;
					else 
						selection = 0;
				}
				else if(KEYDOWN(VK_UP))
				{
					result = system->playSound( FMOD_CHANNEL_FREE, menuBlip, false, &titleChannel);

					//starty -= 100;
					if(selection > 0)
						selection--;
					else 
						selection = 2;
				}

				switch(selection)
				{
				case 0:
					startx = 180;
					starty = 280;
					break;
				case 1:
					startx = 180;
					starty = 385;
					break;
				case 2:
					startx = 180;
					starty = 487;
					break;
				}

				if(KEYDOWN(VK_RETURN))
				{
					result = system->playSound( FMOD_CHANNEL_FREE, menuBlip, false, &titleChannel);
					break;
				}
			}

			dwTime = GetTickCount();
		}

					
	graphics.DrawRectangle(&pen, startx, starty, 247,  73);


		// Copy the Memory DC's Bitmap onto the Display DC's Bitmap.
	BitBlt(hdcDisplay, 0, 0, rClient.right, rClient.bottom,
		hdcMemory, 0, 0, SRCCOPY);

		//Sleep(1500);

	}
	
	Sleep(700);

	int MapSelection = 0;
	int width = 160;
	int height = 130;

//DISPLAY MAP SELECTION SCREEN
if(selection != 2)
{
	while(!KEYDOWN('Q'))
	{
		//TODO: Clear Back Buffer
	FillRect(hdcMemory,&rClient,(HBRUSH)GetStockObject(BLACK_BRUSH));

	//Get dimensions of client
	GetClientRect(hWnd,&rClient);

		BitBlt(hdcMemory, 0, 0, bmTitleMapInfo.bmWidth, bmTitleMapInfo.bmHeight,
		hdcTitleMap, 0, 0, SRCCOPY);

	system->update();

	
		if(GetTickCount() - dwTime > 100) //timeGetTime(), QueryPerformanceCounter
		{
			if(!NextScreen)
			{
				if(KEYDOWN(VK_DOWN))
				{
					result = system->playSound( FMOD_CHANNEL_FREE, menuBlip, false, &titleChannel);

					//starty += 100;
					if(MapSelection < 4)
						MapSelection++;
					else 
						MapSelection = 0;
				}
				else if(KEYDOWN(VK_UP))
				{
					result = system->playSound( FMOD_CHANNEL_FREE, menuBlip, false, &titleChannel);

					//starty -= 100;
					if(MapSelection > 0)
						MapSelection--;
					else 
						MapSelection = 3;
				}

				switch(MapSelection)
				{
				case 0:
					startx = 120;
					starty = 340;
					width = 160;
					height = 130;
					Level = 1;
					break;
				case 1:
					startx = 330;
					starty = 340;
					width = 160;
					height = 130;
					Level = 0;
					break;
				case 2:
					startx = 120;
					starty = 550;
					width = 160;
					height = 130;
					Level = 2;
					break;
				case 3:
					startx = 410;
					starty = 620;
					width = 175;
					height = 55;
					break;
				}

				if(KEYDOWN(VK_RETURN))
				{
					result = system->playSound( FMOD_CHANNEL_FREE, menuBlip, false, &titleChannel);
					break;
				}
			}

			dwTime = GetTickCount();
		}
					
	graphics.DrawRectangle(&pen, startx, starty, width,  height);


		// Copy the Memory DC's Bitmap onto the Display DC's Bitmap.
	BitBlt(hdcDisplay, 0, 0, rClient.right, rClient.bottom,
		hdcMemory, 0, 0, SRCCOPY);

		//Sleep(1500);

	}

}

	titleChannel->setMute(true);

	result = titleMusic->release();

	result = menuBlip->release();

if(MapSelection != 3)
{

	if(selection == 0)
		AIEnabled = true;
	else if(selection == 1)
		AIEnabled = false;

	switch(Level)
	{
	case 0:
		//LEVEL DATA FOR DOWNTOWN
		wsprintf(szLevel, _T("Downtown.bmp"));
		LevelLeftBound = -20;
		LevelRightBound = 964;
		LevelTopBound = 0;
		LevelBottomBound = 688;
		break;
	case 1:
		//LEVEL DATA FOR TheBeach
		wsprintf(szLevel, _T("TheBeach.bmp"));
		LevelLeftBound = 150;
		LevelRightBound = 964;
		LevelTopBound = 0;
		LevelBottomBound = 688;
		break;
	case 2:
		//LEVEL DATA FOR Island
		wsprintf(szLevel, _T("Island.bmp"));
		LevelLeftBound = 170;
		LevelRightBound = 750;
		LevelTopBound = 35;
		LevelBottomBound = 600;
		break;
	}
	
	
	// * * * * * * * * * * * * * * * * * * * * * 
	// Load Level.bmp 
	// * * * * * * * * * * * * * * * * * * * * * 
	hbmLevel = (HBITMAP)LoadImage(hInst, szLevel /*MAKEINTRESOURCE(IDB_NEBULA)*/,
		IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
	if(hbmLevel == NULL)
	{
		MessageBox(0, _T("Could Not Load Level Data"), 0, 0);
	}

	hdcLevel = CreateCompatibleDC(hdcDisplay);

	hbmLevelOld = (HBITMAP)SelectObject(hdcLevel, hbmLevel);

	GetObject(hbmLevel, sizeof(BITMAP), &bmLevelInfo);



	textState = -1;
	alpha = 255;

	//AIEnabled = false;

	bMuteSoundFX = false;
	bMuteMusic = false;

	Player1Shield = 195;
	Player2Shield = 195;

	Player1Score = 0;
	Player2Score = 0;

	ResetGame(Player1Score, Player2Score);

	result = system->playSound( FMOD_CHANNEL_FREE
, bgMusic, bMuteMusic, &musicChannel);

}
else
	Startup();

}

void Game::Shutdown(void)
{
//TODO: Unload Bitmaps/Brushes/Pens/Fonts

//SOUNDS
	result = gunShot->release();
	result = explosion->release();
	result = message->release();
	result = number->release();
	result = bgMusic->release();
	result = win->release();
	result = hit->release();
    result = system->close();
    result = system->release();


	//// * * * * * * * * * * * * * * * * * * * * * 
	//// Unload the Title Bitmap.
	//// * * * * * * * * * * * * * * * * * * * * * 
	SelectObject(hdcTitle, hbmTitleOld);
	DeleteObject(hbmTitle);
	DeleteDC(hdcTitle);

	//// * * * * * * * * * * * * * * * * * * * * * 
	//// Unload the TitleMap Bitmap.
	//// * * * * * * * * * * * * * * * * * * * * * 
	SelectObject(hdcTitleMap, hbmTitleMapOld);
	DeleteObject(hbmTitleMap);
	DeleteDC(hdcTitleMap);

	// * * * * * * * * * * * * * * * * * * * * * 
	// Unload the Player1 Bitmap.
	// * * * * * * * * * * * * * * * * * * * * * 
	SelectObject(hdcPlayer1, hbmPlayer1Old);
	DeleteObject(hbmPlayer1);
	DeleteDC(hdcPlayer1);


	// * * * * * * * * * * * * * * * * * * * * * 
	// Unload the Player1HUD Bitmap.
	// * * * * * * * * * * * * * * * * * * * * * 
	SelectObject(hdcPlayer1HUD, hbmPlayer1HUDOld);
	DeleteObject(hbmPlayer1HUD);
	DeleteDC(hdcPlayer1HUD);


	// * * * * * * * * * * * * * * * * * * * * * 
	// Unload the Player2 Bitmap.
	// * * * * * * * * * * * * * * * * * * * * * 
	SelectObject(hdcPlayer2, hbmPlayer2Old);
	DeleteObject(hbmPlayer2);
	DeleteDC(hdcPlayer2);

	// * * * * * * * * * * * * * * * * * * * * * 
	// Unload the Player2HUD Bitmap.
	// * * * * * * * * * * * * * * * * * * * * * 
	SelectObject(hdcPlayer2HUD, hbmPlayer2HUDOld);
	DeleteObject(hbmPlayer2HUD);
	DeleteDC(hdcPlayer2HUD);


	// * * * * * * * * * * * * * * * * * * * * * 
	// Unload the Player1Target Bitmap.
	// * * * * * * * * * * * * * * * * * * * * * 
	SelectObject(hdcPlayer1Target, hbmPlayer1TargetOld);
	DeleteObject(hbmPlayer1Target);
	DeleteDC(hdcPlayer1Target);


	// * * * * * * * * * * * * * * * * * * * * * 
	// Unload the Player2Target Bitmap.
	// * * * * * * * * * * * * * * * * * * * * * 
	SelectObject(hdcPlayer2Target, hbmPlayer2TargetOld);
	DeleteObject(hbmPlayer2Target);
	DeleteDC(hdcPlayer2Target);

	// * * * * * * * * * * * * * * * * * * * * * 
	// Unload the TargetArrow Bitmap.
	// * * * * * * * * * * * * * * * * * * * * * 
	SelectObject(hdcTargetArrow, hbmTargetArrowOld);
	DeleteObject(hbmTargetArrow);
	DeleteDC(hdcTargetArrow);

	// * * * * * * * * * * * * * * * * * * * * * 
	// Unload the Bomb Bitmap.
	// * * * * * * * * * * * * * * * * * * * * * 
	SelectObject(hdcBomb, hbmBombOld);
	DeleteObject(hbmBomb);
	DeleteDC(hdcBomb);

	// * * * * * * * * * * * * * * * * * * * * * 
	// Unload the Explosion Bitmap.
	// * * * * * * * * * * * * * * * * * * * * * 
	SelectObject(hdcExplosion, hbmExplosionOld);
	DeleteObject(hbmExplosion);
	DeleteDC(hdcExplosion);


	// * * * * * * * * * * * * * * * * * * * * * 
	// Unload the Level Bitmap.
	// * * * * * * * * * * * * * * * * * * * * * 
	SelectObject(hdcLevel, hbmLevelOld);
	DeleteObject(hbmLevel);
	DeleteDC(hdcLevel);

	// * * * * * * * * * * * * * * * * * * * * * 
	// Unload the Numbers Bitmap.
	// * * * * * * * * * * * * * * * * * * * * * 
	SelectObject(hdcScore, hbmScoreOld);
	DeleteObject(hbmScore);
	DeleteDC(hdcScore);


	//TODO: Unload Bitmaps/Brushes/Pens/Fonts
	/*SelectObject(hdcMemory,oldpen);
	DeleteObject(pen);*/



//TODO: Destroy Back Buffer


	// Reselect the Default Bitmap into the Memory DC.
	SelectObject(hdcMemory, hbmOld);

	// Delete the Back Buffer Bitmap.
	DeleteObject(hbmBackBuffer);

	// Delete the Memory DC.
	DeleteDC(hdcMemory);

	// Release the Display DC.
	ReleaseDC(hWnd, hdcDisplay);
}

void Game::GetInput(void)
{
	// Stop processing input if the game window is NOT the foreground window.
	if(GetForegroundWindow() != hWnd)
		return;

//TODO: Read User Input


	// Check if the Escape key is pressed:
	if(GetAsyncKeyState(VK_ESCAPE) & 0x8000)
	{
		// TODO: Escape key down action.

		// Simulate clicking on the [X].
		PostMessage(hWnd, WM_CLOSE, 0, 0);
	}

	if(!AIEnabled)
	{
	
			if(KEYDOWN(VK_UP) && Player2Y > LevelTopBound )//up
			{
				Player2direction = 1;
				Player2Y -= 2;
				p2KeyPressed = true;
			}
			else if(KEYDOWN(VK_DOWN) && Player2Y < LevelBottomBound )//down
			{
				Player2direction = 0;
				Player2Y += 2;
				p2KeyPressed = true;
			}
			else if(KEYDOWN(VK_LEFT) && Player2X > LevelLeftBound) //left
			{
				Player2direction = 3;
				Player2X -= 2;
				p2KeyPressed = true;
			}
			else if(KEYDOWN(VK_RIGHT) && Player2X < LevelRightBound )//right
			{
				Player2direction = 2;
				Player2X += 2;
				p2KeyPressed = true;
			}

	}

	if(KEYDOWN('W') && Player1Y > LevelTopBound)//up
	{
		Player1direction = 1;
		Player1Y -= 2;
		p1KeyPressed = true;
	}
	else if(KEYDOWN('S') && Player1Y < LevelBottomBound)//down
	{
		Player1direction = 0;
		Player1Y += 2;
		p1KeyPressed = true;
	}
	else if(KEYDOWN('A') && Player1X > LevelLeftBound)//left
	{
		Player1direction = 3;
		Player1X -= 2;
		p1KeyPressed = true;
	}
	else if(KEYDOWN('D') && Player1X < LevelRightBound)//right
	{
		Player1direction = 2;
		Player1X += 2;
		p1KeyPressed = true;
	}

static DWORD dwTime = GetTickCount();


	
if(GetTickCount() - dwTime > 100) //timeGetTime(), QueryPerformanceCounter
{
	if(KEYDOWN('Z'))
	{
		Player1CreateBullet();
		 result = system->playSound(FMOD_CHANNEL_FREE, gunShot, bMuteSoundFX, &channel);
	}

	if(!AIEnabled)
	{
		if(KEYDOWN('M'))
		{
			Player2CreateBullet();
			 result = system->playSound(FMOD_CHANNEL_FREE, gunShot, bMuteSoundFX, &channel);
		}
	}

	dwTime = GetTickCount();
}

}

void Game::Simulate(void)
{
	// Get the dimensions of the client.
	GetClientRect(hWnd, &rClient);


	P1.left = Player1X+20;
	P1.right = Player1X+60;
	P1.bottom = Player1Y+80;
	P1.top = Player1Y;

	P2.left = Player2X+20;
	P2.right = Player2X+60;
	P2.bottom = Player2Y+80;
	P2.top = Player2Y;



//TODO: Simulate AI
if(AIEnabled)
{

	if(AIGetBomb)
	{
		if(BombX <= Player2X)
		{
			Player2X -= 2;
			Player2direction = 3;
			p2KeyPressed = true;
		}
		else if(BombX > Player2X)
		{
			Player2X += 2;
			Player2direction = 2;
			p2KeyPressed = true;
		}

		if(BombY >= Player2Y)
		{
			Player2Y += 2;
			Player2direction = 0;
			p2KeyPressed = true;
		}
		else if(BombY < Player2Y)
		{
			Player2Y -= 2;
			Player2direction = 1;
			p2KeyPressed = true;
		}

		//static DWORD dwTime = GetTickCount();
	
		//if(GetTickCount() - dwTime > 100) //timeGetTime(), QueryPerformanceCounter
		//{
		//		if(Player1X < Player2X && Player1Y < (Player2Y + 100) && Player1Y > (Player2Y - 100))
		//		{
		//			result = system->playSound(FMOD_CHANNEL_FREE, gunShot, false, &channel);
		//			Player2CreateBullet();
		//		}
		//	dwTime = GetTickCount();
		//}

		/*if(p2HasBomb)
		{
			AIGetBomb = false;
			AIOffense = true;
		}*/
	}

	if(AIOffense)
	{
		AIPlantBomb = false;
		AIDefuseBomb = false;

		if(!BombHasBeenPlanted)
		{
			if(p2HasBomb)
			{
				if(abs(P2.right - Target1.left) <= 3 && abs(P2.top - Target1.top) <= 60 ||  abs(P2.left - Target1.right) <= 3 && abs(P2.top - Target1.top) <= 60
				|| abs(P2.bottom - Target1.top) <= 3 && abs(P2.right - Target1.right) <= 60 || abs(P2.top - Target1.bottom) <= 3 && abs(P2.right - Target1.right) <= 60)
			{
						AIPlantBomb = true;//TRUE
						AIDefuseBomb = false;
						Player2direction = 3;
						p2KeyPressed = false;
					}
			

				if(Target1.right < Player2X)
				{
					Player2X -= 2;
					Player2direction = 3;
					p2KeyPressed = true;
				}
				else if(Target1.left >= Player2X)
				{
					Player2X += 2;
					Player2direction = 2;
					p2KeyPressed = true;
				}
				
				if(Target1.bottom >= Player2Y) 
				{
					Player2Y += 2;
					Player2direction = 0;
					p2KeyPressed = true;

				}
				else if(Target1.top < Player2Y)
				{
					Player2Y -= 2;
					Player2direction = 1;
					p2KeyPressed = true;
				}

				static DWORD dwTime = GetTickCount();

				if(GetTickCount() - dwTime > 100) //timeGetTime(), QueryPerformanceCounter
				{
						if(Player1X < Player2X && Player1Y < (Player2Y + 100) && Player1Y > (Player2Y - 100))
						{
							Player2direction = 3;
							result = system->playSound(FMOD_CHANNEL_FREE, gunShot, bMuteSoundFX, &channel);
							Player2CreateBullet();
						}
						else if (Player1X > Player2X && Player1Y < (Player2Y + 100) && Player1Y > (Player2Y - 100))
						{
							Player2direction = 2;
							result = system->playSound(FMOD_CHANNEL_FREE, gunShot, bMuteSoundFX, &channel);
							Player2CreateBullet();
						}
						else if(Player1Y < Player2Y && Player1X < (Player2X + 100) && Player1X > (Player2X - 100))
						{
							Player2direction = 1;
							result = system->playSound(FMOD_CHANNEL_FREE, gunShot, bMuteSoundFX, &channel);
							Player2CreateBullet();
						}
						else if(Player1Y > Player2Y && Player1X < (Player2X + 100) && Player1X > (Player2X - 100))
						{
							Player2direction = 0;
							result = system->playSound(FMOD_CHANNEL_FREE, gunShot, bMuteSoundFX, &channel);
							Player2CreateBullet();
						}
							
					dwTime = GetTickCount();
				}
			}
		}

	}
	if(AIDefense)
	{
		int follow = rand() % 2;

		AIPlantBomb = false;
		AIDefuseBomb = false;

		if(!BombHasBeenPlanted)
		{
			if(rand == 0)
			{
				if(Player1X < (Player2X - 50))
				{
					Player2X -= 2;
					Player2direction = 3;
					p2KeyPressed = true;
				}
				else if(Player1X > (Player2X - 50))
				{
					Player2X += 2;
					Player2direction = 2;
					p2KeyPressed = true;
				}
				
				if(Player1Y > (Player2Y - 50)) 
				{
					Player2Y += 2;
					Player2direction = 0;
					p2KeyPressed = true;

				}
				else if(Player1Y < (Player2Y - 50) )
				{
					Player2Y -= 2;
					Player2direction = 1;
					p2KeyPressed = true;
				}

			}
				static DWORD dwTime = GetTickCount();

				if(GetTickCount() - dwTime > 100) //timeGetTime(), QueryPerformanceCounter
				{
						if(Player1X < Player2X && Player1Y < (Player2Y + 100) && Player1Y > (Player2Y - 100))
						{
							Player2direction = 3;
							result = system->playSound(FMOD_CHANNEL_FREE, gunShot, bMuteSoundFX, &channel);
							Player2CreateBullet();
						}
						else if (Player1X > Player2X && Player1Y < (Player2Y + 100) && Player1Y > (Player2Y - 100))
						{
							Player2direction = 2;
							result = system->playSound(FMOD_CHANNEL_FREE, gunShot, bMuteSoundFX, &channel);
							Player2CreateBullet();
						}
						else if(Player1Y < Player2Y && Player1X < (Player2X + 100) && Player1X > (Player2X - 100))
						{
							Player2direction = 1;
							result = system->playSound(FMOD_CHANNEL_FREE, gunShot, bMuteSoundFX, &channel);
							Player2CreateBullet();
						}
						else if(Player1Y > Player2Y && Player1X < (Player2X + 100) && Player1X > (Player2X - 100))
						{
							Player2direction = 0;
							result = system->playSound(FMOD_CHANNEL_FREE, gunShot, bMuteSoundFX, &channel);
							Player2CreateBullet();
						}
							
					dwTime = GetTickCount();
				}
		}
		else
		{

			if(abs(P2.right - Target2.left) <= 3 && abs(P2.top - Target2.top) <= 60 ||  abs(P2.left - Target2.right) <= 3 && abs(P2.top - Target2.top) <= 60
				|| abs(P2.bottom - Target2.top) <= 3 && abs(P2.right - Target2.right) <= 60 || abs(P2.top - Target2.bottom) <= 3 && abs(P2.right - Target2.right) <= 60)
				{
					AIDefuseBomb = true; // TRUE
					AIPlantBomb = false;
					Player2direction = 3;
					p2KeyPressed = false;
				}
			
				if(Target2.right < Player2X)
				{
					Player2X -= 2;
					Player2direction = 3;
					p2KeyPressed = true;
				}
				else if(Target2.left > Player2X)
				{
					Player2X += 2;
					Player2direction = 2;
					p2KeyPressed = true;
				}
				
				if(Target2.bottom > Player2Y) 
				{
					Player2Y += 2;
					Player2direction = 0;
					p2KeyPressed = true;

				}
				else if(Target2.top < Player2Y)
				{
					Player2Y -= 2;
					Player2direction = 1;
					p2KeyPressed = true;
				}


			static DWORD dwTime = GetTickCount();

				if(GetTickCount() - dwTime > 100) //timeGetTime(), QueryPerformanceCounter
				{
						if(Player1X < Player2X && Player1Y < (Player2Y + 100) && Player1Y > (Player2Y - 100))
						{
							Player2direction = 3;
							result = system->playSound(FMOD_CHANNEL_FREE, gunShot, bMuteSoundFX, &channel);
							Player2CreateBullet();
						}
						else if (Player1X > Player2X && Player1Y < (Player2Y + 100) && Player1Y > (Player2Y - 100))
						{
							Player2direction = 2;
							result = system->playSound(FMOD_CHANNEL_FREE, gunShot, bMuteSoundFX, &channel);
							Player2CreateBullet();
						}
						else if(Player1Y < Player2Y && Player1X < (Player2X + 100) && Player1X > (Player2X - 100))
						{
							Player2direction = 1;
							result = system->playSound(FMOD_CHANNEL_FREE, gunShot, bMuteSoundFX, &channel);
							Player2CreateBullet();
						}
						else if(Player1Y > Player2Y && Player1X < (Player2X + 100) && Player1X > (Player2X - 100))
						{
							Player2direction = 0;
							result = system->playSound(FMOD_CHANNEL_FREE, gunShot, bMuteSoundFX, &channel);
							Player2CreateBullet();
						}
							
					dwTime = GetTickCount();
				}
		}
	}
}

		

//TODO: Simulate Physics

//TODO: Simulate Collision Detection & Response

	// Rectangle to Rectangle Intersection:
	RECT rIntersect;
	
	if(!p1HasBomb && !p2HasBomb)
	{
		if(IntersectRect(&rIntersect, &P1, &BombBox))
		{
			p1HasBomb = true;
			p2HasBomb = false;

			AIDefense = true;
			AIOffense = false;

			alpha = 255;
			textState = 0;
			result = system->playSound(FMOD_CHANNEL_FREE, message, bMuteSoundFX, &channel);

		}
		else if(IntersectRect(&rIntersect, &P2, &BombBox))
		{
			p2HasBomb = true;
			p1HasBomb = false;

			AIGetBomb = false;
			AIDefense = false;
			AIOffense = true;

			alpha = 255;
			textState = 1;
			result = system->playSound(FMOD_CHANNEL_FREE, message, bMuteSoundFX, &channel);
		}
	}

	if(IntersectRect(&rIntersect, &P1, &P2))
	{
		//P1P2Intersect = true;
		if(P1.left < P2.left)
			Player1X -= 2;
		else if(P1.right > P2.right)
			Player1X += 2;
		else if(P1.top < P2.top)
			Player1Y -= 2;
		else if(P1.bottom > P2.bottom)
			Player1Y += 2;
	}
	//MAKE SURE PLAYERS DONT GO OUT OF THE MAP
	if(IntersectRect(&rIntersect, &P1, &rClient))
	{
		//P1P2Intersect = true;
		if(P1.left < rClient.left)
			Player1X += 2;
		else if(P1.right > rClient.right)
			Player1X -= 2;
		else if(P1.top < rClient.top)
			Player1Y += 2;
		else if(P1.bottom > rClient.bottom)
			Player1Y -= 2;
	}


	if(IntersectRect(&rIntersect, &P1, &P2))
	{
		//P1P2Intersect = true;
		if(P2.left < P1.left)
			Player2X -= 2;
		else if(P2.right > P1.right)
			Player2X += 2;
		else if(P2.top < P1.top)
			Player2Y -= 2;
		else if(P2.bottom > P1.bottom)
			Player2Y += 2;
	}
	//MAKE SURE PLAYERS DONT GO OUT OF THE MAP
	if(IntersectRect(&rIntersect, &P2, &rClient))
	{
		//P1P2Intersect = true;
		if(P2.left < rClient.left)
			Player2X += 2;
		else if(P2.right > rClient.right)
			Player2X -= 2;
		else if(P2.top < rClient.top)
			Player2Y += 2;
		else if(P2.bottom > rClient.bottom)
			Player2Y -= 2;
	}


	//CHECK AGAINST TARGET COLLISION
	if(IntersectRect(&rIntersect, &P1, &Target1))
	{
		if(P1.left < Target1.left)
			Player1X -= 2;
		else if(P1.right > Target1.right)
			Player1X += 2;
		else if(P1.top < Target1.top)
			Player1Y -= 2;
		else if(P1.bottom > Target1.bottom)
			Player1Y += 2;

	}
	else if(IntersectRect(&rIntersect, &P1, &Target2))
	{
		if(P1.left < Target2.left)
			Player1X -= 2;
		else if(P1.right > Target2.right)
			Player1X += 2;
		else if(P1.top < Target2.top)
			Player1Y -= 2;
		else if(P1.bottom > Target2.bottom)
			Player1Y += 2;


	}

		//CHECK AGAINST TARGET COLLISION
	if(IntersectRect(&rIntersect, &P2, &Target1))
	{
		if(P2.left < Target1.left)
			Player2X -= 2;
		else if(P2.right > Target1.right)
			Player2X += 2;
		else if(P2.top < Target1.top)
			Player2Y -= 2;
		else if(P2.bottom > Target1.bottom)
			Player2Y += 2;
	}
	else if(IntersectRect(&rIntersect, &P2, &Target2))
	{
		if(P2.left < Target2.left)
			Player2X -= 2;
		else if(P2.right > Target2.right)
			Player2X += 2;
		else if(P2.top < Target2.top)
			Player2Y -= 2;
		else if(P2.bottom > Target2.bottom)
			Player2Y += 2;
	}
}

void Game::Render(void)
{
//TODO: Clear Back Buffer
	FillRect(hdcMemory,&rClient,(HBRUSH)GetStockObject(BLACK_BRUSH));

	//Get dimensions of client
	GetClientRect(hWnd,&rClient);

//TODO: Render Game Components

	system->update();

//_____________Map______________

	BitBlt(hdcMemory, 0, 0, rClient.right, rClient.bottom,
		hdcLevel, 0, 0, SRCCOPY);


	////DISPLAYING BOUNDING BOXES

//_____________Player1_____________

	unsigned int Player1Width = bmPlayer1Info.bmWidth>>2;//divide by 4
	unsigned int Player1Height = bmPlayer1Info.bmHeight>>2;

	// Render a bitmap (color-keyed)
	//	To use TransparentBlt, see above.
	if(Player1direction == 0)//down
	{
		TransparentBlt(hdcMemory, Player1X, Player1Y, Player1Width, Player1Height,
		hdcPlayer1, Player1Width*Player1Frame, 0, Player1Width, Player1Height, RGB(255, 0, 255));
	}
	else if (Player1direction == 1)//up
	{
		TransparentBlt(hdcMemory, Player1X, Player1Y, Player1Width, Player1Height,
		hdcPlayer1, Player1Width*Player1Frame, Player1Height, Player1Width, Player1Height, RGB(255, 0, 255));
	}
	else if (Player1direction == 2)//right
	{
		TransparentBlt(hdcMemory, Player1X, Player1Y, Player1Width, Player1Height,
		hdcPlayer1, Player1Width*Player1Frame, Player1Height*2, Player1Width, Player1Height, RGB(255, 0, 255));
	}
	else if (Player1direction == 3)//left
	{
		TransparentBlt(hdcMemory, Player1X, Player1Y, Player1Width, Player1Height,
		hdcPlayer1, Player1Width*Player1Frame, Player1Height*3, Player1Width, Player1Height, RGB(255, 0, 255));
	}


//_____________Player2_____________
	unsigned int Player2Width = bmPlayer2Info.bmWidth>>2;
	unsigned int Player2Height = bmPlayer2Info.bmHeight>>2;


	if(Player2direction == 0)//down
	{
		TransparentBlt(hdcMemory, Player2X, Player2Y, Player2Width, Player2Height,
		hdcPlayer2, Player2Width*Player2Frame, 0, Player2Width, Player2Height, RGB(255, 0, 255));
	}
	else if (Player2direction == 1)//up
	{
		TransparentBlt(hdcMemory, Player2X, Player2Y, Player2Width, Player2Height,
		hdcPlayer2, Player2Width*Player2Frame, Player2Height, Player2Width, Player2Height, RGB(255, 0, 255));
	}
	else if (Player2direction == 2)//right
	{
		TransparentBlt(hdcMemory, Player2X, Player2Y, Player2Width, Player2Height,
		hdcPlayer2, Player2Width*Player2Frame, Player2Height*2, Player2Width, Player2Height, RGB(255, 0, 255));
	}
	else if (Player2direction == 3)//left
	{
		TransparentBlt(hdcMemory, Player2X, Player2Y, Player2Width, Player2Height,
		hdcPlayer2, Player2Width*Player2Frame, Player2Height*3, Player2Width, Player2Height, RGB(255, 0, 255));
	}

	// Measure Time.

	static DWORD dwTime = GetTickCount();


	if(GetTickCount() - dwTime > 100) //timeGetTime(), QueryPerformanceCounter 
	{
		// Animate Player1.
		if(p1KeyPressed)
		{
			Player1Frame++;
			if(Player1Frame == 4)
					Player1Frame = 0;
		}
		else
			Player1Frame = 0;


		// Animate Player2.
		if(p2KeyPressed)
		{
			Player2Frame++;
			if(Player2Frame == 4)
					Player2Frame = 0;
		}
		else
			Player2Frame = 0;

		dwTime = GetTickCount();
	}

	// Calculate the number of frames per one second:
	//dwFrames++;
	//dwCurrentTime = GetTickCount(); // Even better to use timeGetTime()
	//dwElapsedTime = dwCurrentTime - dwLastUpdateTime;
	//if(dwElapsedTime >= 1000)
	//{
	//	wsprintf(szFPS, _T("FPS = %u"), (UINT)(dwFrames * 1000.0 / dwElapsedTime));
	//	dwFrames = 0;
	//	dwLastUpdateTime = dwCurrentTime;
	//}
	//// Write the FPS onto the Memory DC.
	//TextOut(hdcMemory, 0, rClient.bottom - 20, szFPS, lstrlen(szFPS));

	//TODO: Present Back Buffer

	//DRAW BULLETS IF THEY ARE CREATED
	if(Player1BulletArray.size() != 0 || Player2BulletArray.size() != 0)
		DrawBullet();


	//PLAYER1Target
	TransparentBlt(hdcMemory, Target1X, Target1Y, bmPlayer1TargetInfo.bmWidth, bmPlayer1TargetInfo.bmHeight,
		hdcPlayer1Target, 0, 0, bmPlayer1TargetInfo.bmWidth, bmPlayer1TargetInfo.bmHeight, RGB(255, 0, 255));


	//PLAYER2Target
	TransparentBlt(hdcMemory, Target2X, Target2Y, bmPlayer2TargetInfo.bmWidth, bmPlayer2TargetInfo.bmHeight,
		hdcPlayer2Target, 0, 0, bmPlayer2TargetInfo.bmWidth, bmPlayer2TargetInfo.bmHeight, RGB(255, 0, 255));


			//GET CORRECT NUMBER OF FRAMES FOR THE SCORE
	int ScoreFrame = bmScoreInfo.bmWidth/10;

	//Player1Score
	TransparentBlt(hdcMemory,bmPlayer1HUDInfo.bmWidth + 50, 28, ScoreFrame,bmScoreInfo.bmHeight,
			hdcScore, ScoreFrame * Player1Score, 0, ScoreFrame, bmScoreInfo.bmHeight, RGB(255, 0, 255));


	//Player2Score
	TransparentBlt(hdcMemory,1024 - bmPlayer1HUDInfo.bmWidth - 100, 28, ScoreFrame,bmScoreInfo.bmHeight,
			hdcScore, ScoreFrame * Player2Score, 0, ScoreFrame, bmScoreInfo.bmHeight, RGB(255, 0, 255));


	//PLAYER1HUD 
	TransparentBlt(hdcMemory, 50, 30, bmPlayer1HUDInfo.bmWidth, bmPlayer1HUDInfo.bmHeight,
		hdcPlayer1HUD, 0, 0, bmPlayer1HUDInfo.bmWidth, bmPlayer1HUDInfo.bmHeight, RGB(255, 0, 255));

	//PLAYER2HUD 
	TransparentBlt(hdcMemory, 723, 30, bmPlayer2HUDInfo.bmWidth, bmPlayer2HUDInfo.bmHeight,
		hdcPlayer2HUD, 0, 0, bmPlayer2HUDInfo.bmWidth, bmPlayer2HUDInfo.bmHeight, RGB(255, 0, 255));

///////////////////////////////////////////////////////////////////////////
	HPEN pen = CreatePen(PS_NULL,0,0);//RGB(0,255,0));
	HPEN oldpen = (HPEN)SelectObject(hdcMemory,pen);

	//PLAYER1HEALTH/PLAYER2HEALTH
	HBRUSH brush = CreateSolidBrush(RGB(255,0,0));
	HBRUSH oldbrush = (HBRUSH)SelectObject(hdcMemory,brush);
	Rectangle(hdcMemory,103,33,104+Player1Health,51);
	Rectangle(hdcMemory,921-Player2Health,33,922,51);
	SelectObject(hdcMemory,oldbrush);
	DeleteObject(brush);

	//PLAYER1SHEILD/PLAYER2SHEILD
	 brush = CreateSolidBrush(RGB(0,0,255));
	 oldbrush = (HBRUSH)SelectObject(hdcMemory,brush);
	Rectangle(hdcMemory,103,57,104+Player1Shield,75);
	Rectangle(hdcMemory,921-Player2Shield,57,922,75);
	SelectObject(hdcMemory,oldbrush);
	DeleteObject(brush);

	SelectObject(hdcMemory,oldpen);
	DeleteObject(pen);

///////////////////////////////////////////////////////////////////////////


//TransparentBlt(hdcMemory, Player2X, Player2Y, Player2Width, Player2Height,
//		hdcPlayer2, Player2Width*Player2Frame, 0, Player2Width, Player2Height, RGB(255, 0, 255));
//

	//BOMB 
	if(!p1HasBomb && !p2HasBomb)
	{
		TransparentBlt(hdcMemory, BombX, BombY, bmBombInfo.bmWidth, bmBombInfo.bmHeight,
			hdcBomb, 0, 0, bmBombInfo.bmWidth, bmBombInfo.bmHeight, RGB(255, 0, 255));

		//CHECK TO SEE IF THEY ARE GOING TO DEFUSE THE BOMB
		if(BombHasBeenPlanted)
		{
			HBRUSH brush = CreateSolidBrush(RGB(0,0,255));
			HBRUSH oldbrush = (HBRUSH)SelectObject(hdcMemory,brush);
		
			//CHECK IF ITS PLAYER 1 THAT IS DEFUSING BOMB
			if((BombX == ((Target1.right + Target1.left) >> 1) - 10) && (BombY == ((Target1.bottom + Target1.top) >> 1) - 10))
			{
				if(abs(P1.right - Target1.left) < 3 && abs(P1.top - Target1.top) < 60 ||  abs(P1.left - Target1.right) < 3 && abs(P1.top - Target1.top) < 60
					|| abs(P1.bottom - Target1.top) < 3 && abs(P1.right - Target1.right) < 60 || abs(P1.top - Target1.bottom) < 3 && abs(P1.right - Target1.right) < 60)
				{
						if(KEYDOWN(VK_LSHIFT))
							{
										if(BombTime < 80)
										{
											BombTime++;
											Rectangle(hdcMemory,Player1X,Player1Y-5,Player1X + BombTime,Player1Y);
										}
										else
										{
											BombHasBeenPlanted = false;
											p1HasBomb = true; 
											BombTime = 0;
											alpha = 255;
											textState = 4;
											result = system->playSound(FMOD_CHANNEL_FREE, message, bMuteSoundFX, &channel);
										}
							}
							else
							BombTime = 0;
				}
			}
			//CHECK IF ITS PLAYER 2 THAT IS DEFUSING BOMB
			else if((BombX == ((Target2.right + Target2.left) >> 1) - 10) && (BombY == ((Target2.bottom + Target2.top) >> 1) - 10))
			{
				if(!AIEnabled)
					{
						if(abs(P2.right - Target2.left) < 3 && abs(P2.top - Target2.top) < 60 ||  abs(P2.left - Target2.right) < 3 && abs(P2.top - Target2.top) < 60
						|| abs(P2.bottom - Target2.top) < 3 && abs(P2.right - Target2.right) < 60 || abs(P2.top - Target2.bottom) < 3 && abs(P2.right - Target2.right) < 60)
						{

							
								if(KEYDOWN(VK_RSHIFT))
									{
												if(BombTime < 80)
												{
													BombTime++;
													Rectangle(hdcMemory,Player2X,Player2Y-5,Player2X + BombTime,Player2Y);
												}
												else
												{
													BombHasBeenPlanted = false;
													p2HasBomb = true; 
													BombTime = 0;
													alpha = 255;
													textState = 5;
													result = system->playSound(FMOD_CHANNEL_FREE, message, bMuteSoundFX, &channel);
												}
									}
									else
									BombTime = 0;
						}
					}
					else
					{
							if(AIDefuseBomb)
							{
										if(BombTime < 80)
										{
											BombTime++;
											Rectangle(hdcMemory,Player2X,Player2Y-5,Player2X + BombTime,Player2Y);
										}
										else
										{
											BombHasBeenPlanted = false;
											p2HasBomb = true; 
											AIPlantBomb = false;
											AIDefuseBomb = false;
											AIOffense = true;
											AIDefense = false;
											BombTime = 0;
											alpha = 255;
											textState = 5;
											result = system->playSound(FMOD_CHANNEL_FREE, message, bMuteSoundFX, &channel);
										}
							}
							else
							{
								BombTime = 0;
								AIDefuseBomb = false;
								AIPlantBomb = false;
							}
					}
					
				}

			SelectObject(hdcMemory,oldbrush);
			DeleteObject(brush);
			}

	}
	else  //CHECK TO SEE IF THEY ARE GOING TO PLANT THE BOMB
	{
		HBRUSH brush = CreateSolidBrush(RGB(37,239,85));
		HBRUSH oldbrush = (HBRUSH)SelectObject(hdcMemory,brush);

		if(p1HasBomb)
		{
			p2HasBomb = false;

				Rectangle(hdcMemory,0,30,bmBombInfo.bmWidth+30,bmBombInfo.bmHeight+30);

					TransparentBlt(hdcMemory, 15, 30, bmBombInfo.bmWidth,bmBombInfo.bmHeight,
				hdcBomb, 0, 0, bmBombInfo.bmWidth, bmBombInfo.bmHeight, RGB(255, 0, 255));
				
					//DRAW TARGET ARROW 
					TargetArrowX = Target2X + 5;
					TargetArrowY = Target2Y - bmTargetArrowInfo.bmHeight;

					TransparentBlt(hdcMemory, TargetArrowX, TargetArrowY, bmTargetArrowInfo.bmWidth, bmTargetArrowInfo.bmHeight,
			hdcTargetArrow, 0, 0, bmTargetArrowInfo.bmWidth, bmTargetArrowInfo.bmHeight, RGB(255, 0, 255));

			if(abs(P1.right - Target2.left) < 3 && abs(P1.top - Target2.top) < 60 ||  abs(P1.left - Target2.right) < 3 && abs(P1.top - Target2.top) < 60
				|| abs(P1.bottom - Target2.top) < 3 && abs(P1.right - Target2.right) < 60 || abs(P1.top - Target2.bottom) < 3 && abs(P1.right - Target2.right) < 60)
			{
				if(KEYDOWN(VK_LSHIFT))
					{
								if(BombTime < 80)
								{
									BombTime++;
									Rectangle(hdcMemory,Player1X,Player1Y-5,Player1X + BombTime,Player1Y);
								}
								else
								{
									BombX = ((Target2.right + Target2.left) >> 1) - 10;
									BombY = ((Target2.bottom + Target2.top) >> 1) - 10;
									BombBox.left = BombX;
									BombBox.top = BombY;
									BombBox.right = BombX + bmBombInfo.bmWidth;
									BombBox.bottom = BombY + bmBombInfo.bmHeight;
									BombHasBeenPlanted = true;
									p1HasBomb = false;
									BombTime = 0;
									alpha = 255;
									textState = 2;
									result = system->playSound(FMOD_CHANNEL_FREE, message, bMuteSoundFX, &channel);
								}
					}
					else
					BombTime = 0;
			}

		}
		else if(p2HasBomb)
		{
			p1HasBomb = false;

				Rectangle(hdcMemory,723 + bmPlayer2HUDInfo.bmWidth,30,753 + bmPlayer2HUDInfo.bmWidth + bmBombInfo.bmWidth,bmBombInfo.bmHeight + 30);

					TransparentBlt(hdcMemory, 738 + bmPlayer2HUDInfo.bmWidth, 30, bmBombInfo.bmWidth,bmBombInfo.bmHeight,
				hdcBomb, 0, 0, bmBombInfo.bmWidth, bmBombInfo.bmHeight, RGB(255, 0, 255));

					//DRAW TARGET ARROW 
					TargetArrowX = Target1X + 5;
					TargetArrowY = Target1Y - bmTargetArrowInfo.bmHeight;

					TransparentBlt(hdcMemory, TargetArrowX, TargetArrowY, bmTargetArrowInfo.bmWidth, bmTargetArrowInfo.bmHeight,
			hdcTargetArrow, 0, 0, bmTargetArrowInfo.bmWidth, bmTargetArrowInfo.bmHeight, RGB(255, 0, 255));

			if(!AIEnabled)
				{
							if(abs(P2.right - Target1.left) < 3 && abs(P2.top - Target1.top) < 60 ||  abs(P2.left - Target1.right) < 3 && abs(P2.top - Target1.top) < 60
								|| abs(P2.bottom - Target1.top) < 3 && abs(P2.right - Target1.right) < 60 || abs(P2.top - Target1.bottom) < 3 && abs(P2.right - Target1.right) < 60)
							{
								
									if(KEYDOWN(VK_RSHIFT))
										{
													if(BombTime < 80)
													{
														BombTime++;
														Rectangle(hdcMemory,Player2X,Player2Y-5,Player2X + BombTime,Player2Y);
													}
													else
													{
														BombX = ((Target1.right + Target1.left) >> 1) - 10;
														BombY = ((Target1.bottom + Target1.top) >> 1) - 10;
														BombBox.left = BombX;
														BombBox.top = BombY;
														BombBox.right = BombX + bmBombInfo.bmWidth;
														BombBox.bottom = BombY + bmBombInfo.bmHeight;
														BombHasBeenPlanted = true;
														p2HasBomb = false; 
														BombTime = 0;
														alpha = 255;
														textState = 3;
														result = system->playSound(FMOD_CHANNEL_FREE, message, bMuteSoundFX, &channel);
													}
										}
										else
										BombTime = 0;
							}
			}
			else 
			{
				if(AIPlantBomb)
						{
									if(BombTime < 80)
									{
										BombTime++;
										Rectangle(hdcMemory,Player2X,Player2Y-5,Player2X + BombTime,Player2Y);
									}
									else
									{
										BombX = ((Target1.right + Target1.left) >> 1) - 10;
										BombY = ((Target1.bottom + Target1.top) >> 1) - 10;
										BombBox.left = BombX;
										BombBox.top = BombY;
										BombBox.right = BombX + bmBombInfo.bmWidth;
										BombBox.bottom = BombY + bmBombInfo.bmHeight;
										BombHasBeenPlanted = true;
										AIOffense = false;
										AIDefense = true;
										AIDefuseBomb = false;
										AIPlantBomb = false;
										p2HasBomb = false; 
										BombTime = 0;
										alpha = 255;
										textState = 3;
										result = system->playSound(FMOD_CHANNEL_FREE, message, bMuteSoundFX, &channel);
									}
						}
						else
						{
						BombTime = 0;
						AIPlantBomb = false;
						AIDefuseBomb = false;
						}
			}

		}

		
		SelectObject(hdcMemory,oldbrush);
		DeleteObject(brush);
		
	}


	//DRAW EXPLOSIONS
	if(ExplosionArray.size() != 0)
	{	
		DrawExplosion();
	}
	else
	{
		if(Player1Score == 5)
		{
			result = system->playSound(FMOD_CHANNEL_FREE, win, bMuteSoundFX, &channel);
			MessageBox(hWnd,_T("Player 1 has scored 5 points! You win!"),_T("Mafia"),MB_OK);
			Player1Score = 0;
			Player2Score = 0;
			Player1Shield = 195;
		}

		else if(Player2Score == 5)
		{
			result = system->playSound(FMOD_CHANNEL_FREE, win, bMuteSoundFX, &channel);
			MessageBox(hWnd,_T("Player 2 has scored 5 points! You win!"),_T("Mafia"),MB_OK);
			Player1Score = 0;
			Player2Score = 0;
			Player1Shield = 195;
			Player2Shield = 195;
		}
	}
					

	//DRAW MESSAGES 
	Graphics graphics(hdcMemory);

	SolidBrush br(Color(alpha /* alpha */, 255, 0, 0));
	FontFamily fontFamily(_T("Times New Roman"));
	Font font(&fontFamily,34,FontStyleBold,UnitPixel);
	PointF pointF( (float)(rClient.right >> 1) - 200, (float)(rClient.bottom - 40));
	graphics.SetTextRenderingHint(TextRenderingHintAntiAlias);

	static bool draw = false;

	if(!draw)
	{
		if(alpha > 0)
		{
			switch(textState)
			{
			case 0:
				graphics.DrawString(_T("Player 1 has the bomb"), -1, &font, pointF, &br);
				break;
			case 1:
				graphics.DrawString(_T("Player 2 has the bomb"), -1, &font, pointF, &br);			
				break;
			case 2:
				graphics.DrawString(_T("Player 1 planted the bomb"), -1, &font, pointF, &br);	
				break;
			case 3:
				graphics.DrawString(_T("Player 2 planted the bomb"), -1, &font, pointF, &br);	
				break;
			case 4:
				graphics.DrawString(_T("Player 1 defused the bomb"), -1, &font, pointF, &br);		
				break;
			case 5:
				graphics.DrawString(_T("Player 2 defused the bomb"), -1, &font, pointF, &br);	
				break;
			case 6:
				graphics.DrawString(_T("Player 1 gained a point"), -1, &font, pointF, &br);	
				break;
			case 7:
				graphics.DrawString(_T("Player 2 gained a point"), -1, &font, pointF, &br);	
				break;
			default:
				graphics.DrawString(_T("      Round has begun"), -1, &font, pointF, &br);		
				break;

			}
			
		alpha--;
		}
		else
		{
			if(BombHasBeenPlanted)
			{
				alpha = 255;
				draw = true;
			}
		}
	}
	else
	{
		if(BombHasBeenPlanted)
		{
			alpha = 255;

			static DWORD dwTime = GetTickCount();

			if(GetTickCount() - dwTime > 1000 && timer >= 0) 
			{
				timer--;
				result = system->playSound(FMOD_CHANNEL_FREE, number, bMuteSoundFX, &channel);
				alpha = 255;
				dwTime = GetTickCount();
			}

			if(timer < 0)
			{
				//EXPLOSION
				for(int i = 0; i < 20 ; i++)
				{
					frame = 0;
					CreateExplosion();
				}

				result = system->playSound(FMOD_CHANNEL_FREE, explosion, bMuteSoundFX, &channel);

				//Sleep(50);

				if((BombX == ((Target2.right + Target2.left) >> 1) - 10) && (BombY == ((Target2.bottom + Target2.top) >> 1) - 10))
				{
					Player1Score++;
					alpha = 255;
					textState = 6;
					result = system->playSound(FMOD_CHANNEL_FREE, message, bMuteSoundFX, &channel);
				}
				else if((BombX == ((Target1.right + Target1.left) >> 1) - 10) && (BombY == ((Target1.bottom + Target1.top) >> 1) - 10))
				{
					Player2Score++;
					alpha = 255;
					textState = 7;
					result = system->playSound(FMOD_CHANNEL_FREE, message, bMuteSoundFX, &channel);

				}

				draw = false;
				//RESET GAME
				ResetGame(Player1Score, Player2Score);
			}
			if(alpha > 0)
					{
						
							alpha--;
					}		

						TCHAR temp[1];

						Font font(&fontFamily,(float)size,FontStyleBold,UnitPixel);
						PointF pointF( (float)(rClient.right >> 1) - 18, 60) ;
						
						wsprintf(temp, _T("%i"), timer);

						graphics.DrawString(temp, -1, &font, pointF, &br);	
		}
		else
		{
			timer = 4;
			draw = false;
		}
		
	}
	
	// Copy the Memory DC's Bitmap onto the Display DC's Bitmap.
	BitBlt(hdcDisplay, 0, 0, rClient.right, rClient.bottom,
		hdcMemory, 0, 0, SRCCOPY);

	p1KeyPressed = false;
	p2KeyPressed = false;

	Sleep(1);

}

void Game::CreateExplosion(void)
{
	Explosion temp;

	int tempNum = rand() % 2;

	temp.RadiusX = (rand() % 100) - 50;
	temp.RadiusY = (rand() % 100) - 50;


	//MAKE SURE THE EXPLOSION IS AT THE RIGHT TARGET!!
	temp.ExplosionX = (BombX - 30) + temp.RadiusX;
	temp.ExplosionY = (BombY - 30) + temp.RadiusY;

	temp.Frame = 0;

	ExplosionArray.push_back(temp);
}

void Game::Player1CreateBullet(void)
{
	Bullet temp;

	switch(Player1direction)
		{
		case 0://down
			temp.x1 = Player1X+33;
			temp.y1 = Player1Y+55;
			temp.x2 = Player1X+36;
			temp.y2 = Player1Y+65;
			temp.speedx = 0;
			temp.speedy = 7;
			break;
		case 1://up
			temp.x1 = Player1X+50;
			temp.y1 = Player1Y+5;
			temp.x2 = Player1X+53;
			temp.y2 = Player1Y+10;
			temp.speedx = 0;
			temp.speedy = -7;
			break;
		case 2://right
			temp.x1 = Player1X+63;
			temp.y1 = Player1Y+33;
			temp.x2 = Player1X+68;
			temp.y2 = Player1Y+36;
			temp.speedx = 7;
			temp.speedy = 0;
			break;
		case 3://left
			temp.x1 = Player1X;
			temp.y1 = Player1Y+33;
			temp.x2 = Player1X+5;
			temp.y2 = Player1Y+36;
			temp.speedx = -7;
			temp.speedy = 0;
			break;
		}

	Player1BulletArray.push_back(temp);
}

void Game::Player2CreateBullet(void)
{
	Bullet temp;

	switch(Player2direction)
		{
		case 0://down
			temp.x1 = Player2X+33;
			temp.y1 = Player2Y+55;
			temp.x2 = Player2X+36;
			temp.y2 = Player2Y+65;
			temp.speedx = 0;
			temp.speedy = 7;
			break;
		case 1://up
			temp.x1 = Player2X+50;
			temp.y1 = Player2Y+5;
			temp.x2 = Player2X+53;
			temp.y2 = Player2Y+10;
			temp.speedx = 0;
			temp.speedy = -7;
			temp.speedx = 0;
			temp.speedy = -7;
			break;
		case 2://right
			temp.x1 = Player2X+63;
			temp.y1 = Player2Y+33;
			temp.x2 = Player2X+68;
			temp.y2 = Player2Y+36;
			temp.speedx = 7;
			temp.speedy = 0;
			break;
		case 3://left
			temp.x1 = Player2X;
			temp.y1 = Player2Y+33;
			temp.x2 = Player2X+5;
			temp.y2 = Player2Y+36;
			temp.speedx = -7;
			temp.speedy = 0;
			break;
		}

	Player2BulletArray.push_back(temp);
}

void Game::DrawExplosion(void)
{
	int width = bmExplosionInfo.bmWidth/9;

	static DWORD dwTime = GetTickCount();

	for(unsigned int i = 0; i < ExplosionArray.size(); i++)
	{
					
			if(GetTickCount() - dwTime > 50) 
			{
				/*	if(ExplosionArray[i].Frame < 9)
						ExplosionArray[i].Frame++;
					else
						FreeExplosion();*/

					if(frame < 9)
						frame++;
					else 
						FreeExplosion();

				dwTime = GetTickCount();
			}

			if(ExplosionArray.size() > 0)// && ExplosionArray[i].Frame != 0)
			{
			TransparentBlt(hdcMemory, ExplosionArray[i].ExplosionX, ExplosionArray[i].ExplosionY, width, bmExplosionInfo.bmHeight,
					hdcExplosion, width*frame/*ExplosionArray[i].Frame */, 0, width, bmExplosionInfo.bmHeight, RGB(255, 0, 255));
			}
	}


	//int temp2 = ExplosionArray.size();
	//TCHAR Size2[32];

	//wsprintf(Size2, _T("ExplosionArray = %i"), temp2);
	//// Write the FPS onto the Memory DC.
	//TextOut(hdcMemory, 0, rClient.bottom - 80, Size2, lstrlen(Size2));

}

void Game::DrawBullet(void)
{
	HPEN pen = CreatePen(PS_SOLID,1,RGB(0,0,0));
	HPEN oldpen = (HPEN)SelectObject(hdcMemory,pen);

	//PLAYER1HEALTH/PLAYER2HEALTH
	HBRUSH brush = CreateSolidBrush(RGB(255,0,0));
	HBRUSH oldbrush = (HBRUSH)SelectObject(hdcMemory,brush);



	for(unsigned int i = 0; i < Player1BulletArray.size(); i++)
	{
		Player1BulletArray[i].bulletBox.left = Player1BulletArray[i].x1 += Player1BulletArray[i].speedx;
		Player1BulletArray[i].bulletBox.top = Player1BulletArray[i].y1 += Player1BulletArray[i].speedy;
		Player1BulletArray[i].bulletBox.right = Player1BulletArray[i].x2 += Player1BulletArray[i].speedx;
		Player1BulletArray[i].bulletBox.bottom = Player1BulletArray[i].y2 += Player1BulletArray[i].speedy;

		//Ellipse(hdcMemory,BulletArray[i].x1,BulletArray[i].y1,BulletArray[i].x2,BulletArray[i].y2); 
		Rectangle(hdcMemory,Player1BulletArray[i].x1 += Player1BulletArray[i].speedx,Player1BulletArray[i].y1 += Player1BulletArray[i].speedy,
			Player1BulletArray[i].x2 += Player1BulletArray[i].speedx,Player1BulletArray[i].y2 += Player1BulletArray[i].speedy); 

		//CHECK FOR COLLISION
		RECT rIntersect;

		if(IntersectRect(&rIntersect, &Player1BulletArray[i].bulletBox, &P2))
		{
			result = system->playSound(FMOD_CHANNEL_FREE, hit, bMuteSoundFX, &channel);

			Player1FreeBullet(i);
			if(Player2Shield > 4)
				Player2Shield -= 10;
			else 
			{
				Player2Health -= 10;
				if(Player2Health < 0)
				{
					/*if(Player2Score > 0)
						Player2Score--;*/

					if(p2HasBomb)
					{
						BombX = Player2X;
						BombY = Player2Y;
						BombBox.left = BombX;
						BombBox.top = BombY;
						BombBox.right = BombX + bmBombInfo.bmWidth;
						BombBox.bottom = BombY + bmBombInfo.bmHeight;
						p2HasBomb = false;
					}

					Player2Health = 195;
					switch(Level)
					{
					case 0:
						Player2X = 960;
						Player2Y = 50;
						break;
					case 1:
						Player2X = 960;
						Player2Y = 50;
						break;
					case 2:
						Player2X = 700;
						Player2Y = 50;
						break;
					}
				}
			}
				
		}
		else if(Player1BulletArray[i].x1 > 1024 || Player1BulletArray[i].x1 < 0 || Player1BulletArray[i].y1 < 0 || Player1BulletArray[i].y1 > 768 
			|| IntersectRect(&rIntersect, &Player1BulletArray[i].bulletBox, &Target1) || IntersectRect(&rIntersect, &Player1BulletArray[i].bulletBox, &Target2))
		{		
		///	result = system->playSound(FMOD_CHANNEL_FREE, hit, false, &channel);

			Player1FreeBullet(i);
		}
	}

	for(unsigned int i = 0; i < Player2BulletArray.size(); i++)
	{
		Player2BulletArray[i].bulletBox.left = Player2BulletArray[i].x1 += Player2BulletArray[i].speedx;
		Player2BulletArray[i].bulletBox.top = Player2BulletArray[i].y1 += Player2BulletArray[i].speedy;
		Player2BulletArray[i].bulletBox.right = Player2BulletArray[i].x2 += Player2BulletArray[i].speedx;
		Player2BulletArray[i].bulletBox.bottom = Player2BulletArray[i].y2 += Player2BulletArray[i].speedy;


		//Ellipse(hdcMemory,BulletArray[i].x1,BulletArray[i].y1,BulletArray[i].x2,BulletArray[i].y2); 
		Rectangle(hdcMemory,Player2BulletArray[i].x1 += Player2BulletArray[i].speedx,Player2BulletArray[i].y1 += Player2BulletArray[i].speedy,
			Player2BulletArray[i].x2 += Player2BulletArray[i].speedx,Player2BulletArray[i].y2 += Player2BulletArray[i].speedy); 

	
		//CHECK FOR COLLISION
		RECT rIntersect;

		if(IntersectRect(&rIntersect, &Player2BulletArray[i].bulletBox, &P1))
		{		
			result = system->playSound(FMOD_CHANNEL_FREE, hit, bMuteSoundFX, &channel);

			Player2FreeBullet(i);
			if(Player1Shield > 4)
				Player1Shield -= 10;
			else 
			{
				Player1Health -= 10;
				if(Player1Health < 0)
				{
					/*if(Player1Score > 0)
						Player1Score--;*/

					if(p1HasBomb)
					{
						BombX = Player1X;
						BombY = Player1Y;
						BombBox.left = BombX;
						BombBox.top = BombY;
						BombBox.right = BombX + bmBombInfo.bmWidth;
						BombBox.bottom = BombY + bmBombInfo.bmHeight;
						p1HasBomb = false;
						AIGetBomb = true;
					}

					Player1Health = 195;

					switch(Level)
					{
					case 0:
						Player1X = 20;
						Player1Y = 50;
						break;
					case 1:
						Player1X = 200;
						Player1Y = 700;
						break;
					case 2:
						Player1X = 200;
						Player1Y = 570;
						break;
					}
				}
			}
		}
		else if(Player2BulletArray[i].x1 > 1024 || Player2BulletArray[i].x1 < 0 || Player2BulletArray[i].y1 < 0 || Player2BulletArray[i].y1 > 768
			|| IntersectRect(&rIntersect, &Player2BulletArray[i].bulletBox, &Target1) || IntersectRect(&rIntersect, &Player2BulletArray[i].bulletBox, &Target2))
		{
			//result = system->playSound(FMOD_CHANNEL_FREE, hit, false, &channel);
			Player2FreeBullet(i);
		}
	}


	SelectObject(hdcMemory,oldbrush);
	DeleteObject(brush);

	SelectObject(hdcMemory,oldpen);
	DeleteObject(pen);

	//int temp = Player1BulletArray.size();
	//TCHAR Size[32];

	//wsprintf(Size, _T("P1BulletArraySize = %i"), temp);
	//// Write the FPS onto the Memory DC.
	//TextOut(hdcMemory, 0, rClient.bottom - 60, Size, lstrlen(Size));

	//int temp2 = Player2BulletArray.size();
	//TCHAR Size2[32];

	//wsprintf(Size2, _T("P2BulletArraySize = %i"), temp2);
	//// Write the FPS onto the Memory DC.
	//TextOut(hdcMemory, 0, rClient.bottom - 80, Size2, lstrlen(Size2));

}
void Game::FreeExplosion()//int i)
{
	ExplosionArray.erase(ExplosionArray.begin());
}

void Game::Player1FreeBullet(int i)
{
		Player1BulletArray.erase(Player1BulletArray.begin()+i);
}

void Game::Player2FreeBullet(int i)
{
		Player2BulletArray.erase(Player2BulletArray.begin()+i);
}

void Game::ResetGame(int &Player1Score, int &Player2Score)
{

	switch(Level)
	{
	case 0://DOWNTOWN
		BombX = 500;
		BombY = 130;

		Target1X = 100;
		Target1Y = 400;
		Target2X = 830;
		Target2Y = 600;

		Player1X = 20;
		Player1Y = 50;
		Player2X = 960;
		Player2Y = 50;
		break;
	case 1://THEBEACH
		BombX = 600;
		BombY = 400;

		Target1X = 250;
		Target1Y = 100;
		Target2X = 900;
		Target2Y = 600;

		Player1X = 200;
		Player1Y = 700;
		Player2X = 960;
		Player2Y = 50;
		break;
	case 2://ISLAND
		BombX = 500;
		BombY = 370;

		Target1X = 250;
		Target1Y = 100;
		Target2X = 700;
		Target2Y = 600;

		Player1X = 200;
		Player1Y = 570;
		Player2X = 700;
		Player2Y = 50;
		break;
	}


	BombBox.left = BombX;
	BombBox.top = BombY;
	BombBox.right = BombX + bmBombInfo.bmWidth;
	BombBox.bottom = BombY + bmBombInfo.bmHeight;
	BombHasBeenPlanted = false;

	
	Target1.left = Target1X;
	Target1.top = Target1Y;
	Target1.right = Target1X + bmPlayer1TargetInfo.bmWidth;
	Target1.bottom = Target1Y + bmPlayer1TargetInfo.bmHeight;

	
	Target2.left = Target2X;
	Target2.top = Target2Y;
	Target2.right = Target2X + bmPlayer2TargetInfo.bmWidth;
	Target2.bottom = Target2Y + bmPlayer2TargetInfo.bmHeight;

	TargetArrowX = 0;
	TargetArrowY = 0;

	BombTime = 0;
	size = 50;
	timer = 4;

	
	AIOffense = false;
	AIDefense = false;
	//AIGetBomb = true;

	AIPlantBomb = false;
	AIDefuseBomb = false;


	int temp = rand() % 2;
	if(temp != 0)
		AIGetBomb = true;
	else
		AIGetBomb = false;


//TODO: Initialize Game Components
	Player1direction = 0;
	Player1Frame = 0;
	Player1Health = 195;
	Player1Score = Player1Score;
	p1KeyPressed = false;
	p1HasBomb = false;


	Player2direction = 0;
	Player2Frame = 0;
	Player2Health = 195;
	Player2Score = Player2Score;
	p2KeyPressed = false;
	p2HasBomb = false;

	Sleep(300);
}
