// MultiThreaded.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "MultiThreaded.h"
#include <commdlg.h>
#include <fstream>
using namespace std;

// Include Multi-Threading functions:
#include <process.h>


#include <gdiplus.h>
using namespace Gdiplus;

#pragma comment(lib, "gdiplus.lib")


//// Include the Windows Multimedia Library:
#include <mmsystem.h>               // Multimedia header file.
#pragma comment(lib, "winmm.lib")   // Multimedia import library.


// Include the Game Class:
#include "Game.h"

// Window constants:
#define CLIENT_WIDTH 1024
#define CLIENT_HEIGHT 768


#define MAX_LOADSTRING 100

// Global Variables: Application properties.
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

struct Document
{
	BOOL bModified;
	TCHAR szFileName[MAX_PATH];
	TCHAR tempName[MAX_PATH];
} theDoc;
// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int, HWND&);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

// Menu Event Handlers
void OnFileNew(HWND);
void OnFileOpen(HWND);
void OnFileSave(HWND);
void OnFileSaveAs(HWND);
void OnFileClose(HWND);


BOOL bFullScreen = false;

BOOL bPaused = false;

void SetDisplayMode(int iWidth, int iHeight, int iBpp, int iRefreshRate);

void ToggleFullscreenMode(HWND hWnd, BOOL bFullScreen,
			int iWidth, int iHeight, int iBpp, int iRefreshRate);

// Displays application title and currrently open document in the window's title bar.
void SetWindowTitle(HWND hWnd, LPCTSTR szFilename)
{
	// Temporary buffer.
	TCHAR szTemp[MAX_PATH];

	wsprintf(theDoc.tempName,szFilename);

	// Combine strings.
	wsprintf(szTemp, _T("%s - %s"), szTitle, szFilename);

	// Write Combined string to title bar.
	SetWindowText(hWnd, szTemp);
}

// Determine what to do with the current document when it has been modfied and the user is requesting a new document.
BOOL ClearDocument(HWND hWnd)
{

	if(theDoc.bModified == TRUE)
	{
		TCHAR szTemp[MAX_PATH];

		// Combine strings.
		wsprintf(szTemp, _T("Do you want to save changes to %s ?"), theDoc.tempName);

		int answer = MessageBox(hWnd,szTemp,_T("Mafia..."),MB_YESNOCANCEL);

		switch(answer)
		{
		case IDYES:
			OnFileSave(hWnd);
			break;

		case IDNO:
			break;

		case IDCANCEL:
			return FALSE;
			break;
		}
	}
	return TRUE;
}


// Prototype: The Game Thread
unsigned int WINAPI GameMain(void* lpvArgList);
void OnIdle()
{

}

int APIENTRY _tWinMain(HINSTANCE hInstance,
					   HINSTANCE hPrevInstance,
					   LPTSTR    lpCmdLine,
					   int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;
	HWND hWnd;

	// Global Variables: The Game Class.
	Game pong;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_MULTITHREADED, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow, hWnd)) // Return HWND by Reference
	{
		return FALSE;
	}

	SetWindowLongPtr(hWnd, GWLP_USERDATA, (LONG)&pong);


	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_MULTITHREADED));


	// Increase the accuracy/precision of the Windows timer:
	TIMECAPS tc;
	timeGetDevCaps(&tc, sizeof(TIMECAPS));
	timeBeginPeriod(tc.wPeriodMin);


	// Create the Game Thread:
	HANDLE hGameThread = (HANDLE)_beginthreadex(NULL, 0, GameMain, hWnd, 0, NULL);
	Sleep(1); // Sleep after the thread is created for debugging to work properly.


	//// Idle-Time Driven Main Message loop:
	//while(true)
	//{
	//	if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
	//	{
	//		if(msg.message == WM_QUIT)
	//			break;

	//		if(!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
	//		{
	//			TranslateMessage(&msg);
	//			DispatchMessage(&msg);
	//		}
	//	}
	//	else
	//	{
	//		OnIdle();
	//	}
	//}

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}


	// Wait until Game Thread terminates:
	WaitForSingleObject(hGameThread, INFINITE);
	// Destroy the Game Thread:
	CloseHandle(hGameThread);


	// Restore the accuracy/precision of the Windows timer:
	timeEndPeriod(tc.wPeriodMin);


	return (int) msg.wParam;
}


// Entry point function for the game:
unsigned int WINAPI GameMain(void* lpvArgList)
{
	GdiplusStartupInput gdiplusStartupInput;
   ULONG_PTR           gdiplusToken;
   
   // Initialize GDI+.
   GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);


	// The argument list contains the program's HWND.
	HWND hWnd = (HWND)lpvArgList;
	Game * pong = (Game*)GetWindowLongPtr(hWnd, GWLP_USERDATA);
	//Game* pong = Game::GetInstance()


	

	pong->SetHwnd(hWnd);
	pong->Startup();


	if(pong->AIEnabled)
				CheckMenuItem(GetMenu(hWnd),ID_EDIT_ENABLEAI, MF_BYCOMMAND | MF_CHECKED);
			else
				CheckMenuItem(GetMenu(hWnd),ID_EDIT_ENABLEAI, MF_BYCOMMAND | MF_UNCHECKED);

	// Real-time main game Loop:
	while(pong->bRunning)
	{
		EnableMenuItem(GetMenu(hWnd),ID_FILE_NEW, MF_ENABLED);
		EnableMenuItem(GetMenu(hWnd),ID_FILE_OPEN, MF_ENABLED);
		EnableMenuItem(GetMenu(hWnd),ID_FILE_SAVE, MF_ENABLED);
		EnableMenuItem(GetMenu(hWnd),ID_FILE_SAVEAS, MF_ENABLED);
		EnableMenuItem(GetMenu(hWnd),IDM_EXIT, MF_ENABLED);
		EnableMenuItem(GetMenu(hWnd),ID_EDIT_ENABLEAI, MF_ENABLED);
		EnableMenuItem(GetMenu(hWnd),ID_EDIT_PAUSE, MF_ENABLED);

		if(pong->selection == 2)
		{
			// Stop the game.
			//pong->Shutdown();
			//PostMessage(hWnd,WM_CLOSE,0,0);
			// Destroy the Window.
			//DestroyWindow(hWnd);
			//break;
		}

		if(!bPaused)
		{
			theDoc.bModified = TRUE;
			//pong->channel->setPaused(false);
			pong->GetInput();
			pong->Simulate();
			pong->Render();
		}
		else
		{
			//pong->channel->setPaused(true);

		//	pong->Render();
			TextOut(pong->getMemoryDC(),500,400,_T("Paused"),6);
			TextOut(GetDC(hWnd),500,400,_T("Paused"),6);
		}
			
		

		// Relinquish the CPU voluntarily.
		Sleep(1);
	}

	pong->Shutdown();

	return 0;
}


//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_MULTITHREADED);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_ICON1));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow, HWND& hWnd)
{
	//
	//The local HWND variable has been promoted to a parameter (reference).
	//

	hInst = hInstance; // Store instance handle in our global variable

	SetDisplayMode(CLIENT_WIDTH,CLIENT_HEIGHT,32,60);


	// Calculate the exact window size that can contain the desired client:
	RECT rDesiredClient;
	rDesiredClient.left = 0;
	rDesiredClient.top = 0;
	rDesiredClient.right = CLIENT_WIDTH;
	rDesiredClient.bottom = CLIENT_HEIGHT;
	AdjustWindowRectEx(&rDesiredClient, WS_OVERLAPPEDWINDOW, TRUE, 0);

	// Create a main window large enough to contain the desired client
	//  and positioned in the center on the screen:
	int iWindowWidth = rDesiredClient.right - rDesiredClient.left;
	int iWindowHeight = rDesiredClient.bottom - rDesiredClient.top;
	
	hWnd = CreateWindowEx(0, szWindowClass, szTitle, WS_OVERLAPPEDWINDOW | WS_BORDER,
		(GetSystemMetrics(SM_CXSCREEN)/2) - (iWindowWidth/2),
		(GetSystemMetrics(SM_CYSCREEN)/2) - (iWindowHeight/2),
		iWindowWidth, iWindowHeight,
		NULL, NULL, hInstance, NULL);

	if (!hWnd)
	{
		return FALSE;
	}

   ToggleFullscreenMode(hWnd, true, CLIENT_WIDTH,CLIENT_HEIGHT,32,60);

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	Game * pong = (Game*)GetWindowLongPtr(hWnd, GWLP_USERDATA);


	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case ID_FILE_NEW:
			bPaused = true;
			OnFileNew(hWnd);
			break;
		case ID_FILE_OPEN:
			bPaused = true;
			OnFileOpen(hWnd);
			break;
		case ID_FILE_SAVE:
			bPaused = true;
			OnFileSave(hWnd);
			break;
		case ID_FILE_SAVEAS:
			bPaused = true;
			OnFileSaveAs(hWnd);
			break;
		case ID_HELP_GAMEINFO:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG1), hWnd, About);
			break;
		case IDM_EXIT:
			// Simulate clicking on the [X].
			OnFileClose(hWnd);
			//PostMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		/*case ID_CHANGEMAP_DOWNTOWN:
			pong->SetLevel(0);
			break;
		case ID_CHANGEMAP_THEBEACH:
			pong->SetLevel(1);
			break;
		case ID_CHANGEMAP_ISLAND:
			pong->SetLevel(2);
			break;*/
		case ID_EDIT_ENABLEAI:
			pong->AIEnabled = !pong->AIEnabled;

			if(pong->AIEnabled)
				CheckMenuItem(GetMenu(hWnd),ID_EDIT_ENABLEAI, MF_BYCOMMAND | MF_CHECKED);
			else
				CheckMenuItem(GetMenu(hWnd),ID_EDIT_ENABLEAI, MF_BYCOMMAND | MF_UNCHECKED);

			break;
		case ID_EDIT_PAUSEMUSIC:
			pong->ToggleMusic();

			if(pong->MuteMusic())
				CheckMenuItem(GetMenu(hWnd),ID_EDIT_PAUSEMUSIC, MF_BYCOMMAND | MF_CHECKED);
			else
				CheckMenuItem(GetMenu(hWnd),ID_EDIT_PAUSEMUSIC, MF_BYCOMMAND | MF_UNCHECKED);
			break;
		case ID_EDIT_PAUSESOUNDFX:
			pong->ToggleFX();

			if(pong->MuteFX())
				CheckMenuItem(GetMenu(hWnd),ID_EDIT_PAUSESOUNDFX, MF_BYCOMMAND | MF_CHECKED);
			else
				CheckMenuItem(GetMenu(hWnd),ID_EDIT_PAUSESOUNDFX, MF_BYCOMMAND | MF_UNCHECKED);
			break;
		case ID_PAUSED:
		case ID_EDIT_PAUSE:
			bPaused = !bPaused;
			if(bPaused)
				CheckMenuItem(GetMenu(hWnd),ID_EDIT_PAUSE, MF_BYCOMMAND | MF_CHECKED);
			else
				CheckMenuItem(GetMenu(hWnd),ID_EDIT_PAUSE, MF_BYCOMMAND | MF_UNCHECKED);

			break;
		case ID_TOGGLEFULLSCREEN:
		case ID_EDIT_FULLSCREEN:
			bFullScreen = !bFullScreen;
		if(bFullScreen)
		{
			// Go Windowed Mode.
			ToggleFullscreenMode(hWnd, FALSE, 0, 0, 0, 0);
		}
		else
		{
			// Go Fullscreen Mode.
			HDC hdc = GetDC(hWnd);
			ToggleFullscreenMode(hWnd, TRUE,
				CLIENT_WIDTH, CLIENT_HEIGHT,
				GetDeviceCaps(hdc, BITSPIXEL),
				GetDeviceCaps(hdc, VREFRESH));
			ReleaseDC(hWnd, hdc);
		}
		EndPaint(hWnd, &ps);
		
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;

	case WM_ERASEBKGND:
		// Prevent Windows from erasing the background.
		//	The background will be erased by OnIdle.
		return TRUE;

	case WM_PAINT:
		//ValidateRect(hWnd, NULL);
				hdc = BeginPaint(hWnd, &ps);
		//// TODO: Add any drawing code here...
		
		break;

	case WM_CLOSE:
		
			//OnFileClose(hWnd);

		if(ClearDocument(hWnd))
		{
			Game * pong;
			pong = (Game*)GetWindowLongPtr(hWnd, GWLP_USERDATA);

			// Stop the game.
			pong->bRunning = FALSE;

			// Destroy the Window.
			DestroyWindow(hWnd);
		}

		break;

	case WM_DESTROY:

		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	} 
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}


// Function that sets the display's resolution:
void SetDisplayMode(int iWidth, int iHeight, int iBpp, int iRefreshRate)
{
	if(iWidth == 0 && iHeight == 0 && iBpp == 0 && iRefreshRate == 0)
	{
		// Restore display settings to those stored in the registry.
		ChangeDisplaySettings(NULL, 0);
		return;
	}

	DEVMODE dm;
	dm.dmSize = sizeof(DEVMODE);

	int i = 0;
	while(EnumDisplaySettings(NULL, i++, &dm))
	{
		// Iterate through the display settings until a match is found.
		if(dm.dmPelsWidth == iWidth && dm.dmPelsHeight == iHeight &&
			dm.dmBitsPerPel == iBpp && dm.dmDisplayFrequency == iRefreshRate)
		{
			if(ChangeDisplaySettings(&dm, CDS_TEST) == DISP_CHANGE_SUCCESSFUL)
			{
				// Put the new settings into effect.
				ChangeDisplaySettings(&dm, CDS_FULLSCREEN);
				return;
			}
		}
	}
}


// Function that toggles a window between fullscreen and windowed mode:
void ToggleFullscreenMode(HWND hWnd, BOOL bFullScreen,
			int iWidth, int iHeight, int iBpp, int iRefreshRate)
{
	static RECT rWindow = {0,0,CLIENT_WIDTH,CLIENT_HEIGHT};
	static HMENU hMenu = NULL;

	if(bFullScreen)
	{
		// Remember the window position.
		GetWindowRect(hWnd, &rWindow);
		// Switch to the requested display mode.
		SetDisplayMode(iWidth, iHeight, iBpp, iRefreshRate);
		// Remember the menu, then remove it.
		hMenu = GetMenu(hWnd);
		SetMenu(hWnd, NULL);
		// Remove the window's title bar.
		SetWindowLongPtr(hWnd, GWL_STYLE, WS_POPUP);
		// Put the changes to the window into effect.
		SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0,
			SWP_FRAMECHANGED | SWP_SHOWWINDOW | SWP_NOMOVE | SWP_NOSIZE);
		// Size the window to cover the entire screen.
		SetWindowPos(hWnd, 0,
			0, 0,
			GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN),
			SWP_NOZORDER);
		// Remove the cursor.
		ShowCursor(FALSE);
	}
	else
	{
		// Restore the display mode.
		SetDisplayMode(0, 0, 0, 0);
		// Restore the window's menu.
		SetMenu(hWnd, hMenu);
		// Restore the window's title bar.
		SetWindowLongPtr(hWnd, GWL_STYLE, WS_OVERLAPPEDWINDOW & ~WS_THICKFRAME & ~WS_MAXIMIZEBOX);
		// Put the changes to the window into effect.
		SetWindowPos(hWnd, HWND_NOTOPMOST, 0, 0, 0, 0,
			SWP_FRAMECHANGED | SWP_SHOWWINDOW | SWP_NOMOVE | SWP_NOSIZE);
		// Size the window to its original position.
		int iWindowWidth = rWindow.right - rWindow.left;
		int iWindowHeight = rWindow.bottom - rWindow.top;
		SetWindowPos(hWnd, 0,
			rWindow.left,
			rWindow.top,
			iWindowWidth, iWindowHeight,
			SWP_NOZORDER);
		// Restore the cursor.
		ShowCursor(TRUE);
	}
}




/////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
// Menu Event Handlers
void OnFileNew(HWND hWnd)
{
	if(ClearDocument(hWnd))
	{
			Game * pong = (Game*)GetWindowLongPtr(hWnd, GWLP_USERDATA);
			theDoc.bModified = FALSE;
			SetWindowTitle(hWnd,_T("Untitled"));
		pong->NewGame();
		bPaused = false;
	}

	bPaused = false;
}


void OnFileOpen(HWND hWnd)
{
	//// Because the user can cancel out of the dialog box we can't overwrite the global file name yet.
	//// Write it to this temporary buffer and if the user closes the dialog by selecteing the OK button the update the global string.
	TCHAR szTemp[MAX_PATH] = {0};
	wsprintf(szTemp,theDoc.szFileName);

	// Structure to fill in
	OPENFILENAME ofn;

	// Clear structure.
	ZeroMemory(&ofn, sizeof(ofn));

	// Struct size and owner window.
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hWnd;

	// Where to return the choosen file name.
	ofn.lpstrFile = szTemp;
	ofn.lpstrFile[0] = 0;
	ofn.nMaxFile = MAX_PATH;

	// Set the filter extensions.
	ofn.lpstrFilter = _T("All Files (*.*)\0*.*\0MAF Files (*.maf)\0*.maf\0");
	ofn.nFilterIndex = 2;

	// Set the default file extension.
	//ofn.lpstrDefExt = _T("hlw");

	ofn.Flags = OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST;

	if(GetOpenFileName(&ofn))
	{
		if(ClearDocument(hWnd))
		{
			wsprintf(theDoc.szFileName,szTemp);
			 // Use the input and output stream libraries your already familier with.
			 //Open a file stream and read in the data.
			ifstream fin(theDoc.szFileName, std::ios_base::in | std::ios_base::binary);
			
			if(fin.is_open())
			{
				Game * pong = (Game*)GetWindowLongPtr(hWnd, GWLP_USERDATA);
				int temp1 = 0;
				int temp2 = 0;
				bool temp3 = 0;

				fin.read((char *)&temp1,sizeof(temp1));
				fin.read((char *)&temp2,sizeof(temp2));
				fin.read((char *)&temp3,sizeof(temp3));

				pong->SetScores(temp1,temp2);
				pong->AIEnabled = temp3;

				if(pong->AIEnabled)
				CheckMenuItem(GetMenu(hWnd),ID_EDIT_ENABLEAI, MF_BYCOMMAND | MF_CHECKED);
			else
				CheckMenuItem(GetMenu(hWnd),ID_EDIT_ENABLEAI, MF_BYCOMMAND | MF_UNCHECKED);

				fin.close();
			}


			 //Set the main window title
			SetWindowTitle(hWnd, &ofn.lpstrFile[ofn.nFileOffset]);
			InvalidateRect(hWnd, NULL, TRUE);

		}
		
	}

	bPaused = false;
}



void OnFileSave(HWND hWnd)
{
	if(theDoc.szFileName[0] == 0)
	{
		//get a file name
		OnFileSaveAs(hWnd);
	}
	else
	{
		//Open stream write data
		ofstream fout(theDoc.szFileName, std::ios_base::out | std::ios_base::trunc | std::ios_base::binary);
		if(fout.is_open())
		{
			Game * pong = (Game*)GetWindowLongPtr(hWnd, GWLP_USERDATA);

			int temp1 = pong->GetP1Score();
			int temp2 = pong->GetP2Score();

			fout.write((char *)&temp1,sizeof(int));
			fout.write((char *)&temp2,sizeof(int));
			fout.write((char *)&pong->AIEnabled,sizeof(bool));

		}

		fout.close();
	}

	bPaused = false;
}


void OnFileSaveAs(HWND hWnd)
{

	// Structure to fill in
	OPENFILENAME ofn;

	// Clear structure.
	ZeroMemory(&ofn, sizeof(ofn));

	// Struct size and owner window.
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hWnd;

	// Where to return the choosen file name.
	ofn.lpstrFile = theDoc.szFileName;
	ofn.nMaxFile = MAX_PATH;

	// Set the filter extensions.
	ofn.lpstrFilter = _T("All Files (*.*)\0*.*\0MAF Files (*.maf)\0*.maf\0");
	ofn.nFilterIndex = 2;

	// Set the default file extension.
	ofn.lpstrDefExt = _T("maf");

	ofn.Flags = OFN_CREATEPROMPT;

	if(GetSaveFileName(&ofn))
	{
			 // Use the input and output stream libraries your already familier with.
			 //Open a file stream and write in the data.
		ofstream fout(theDoc.szFileName, std::ios_base::out | std::ios_base::trunc | std::ios_base::binary);

		if(fout.is_open())
		{
			Game * pong = (Game*)GetWindowLongPtr(hWnd, GWLP_USERDATA);

			int temp1 = pong->GetP1Score();
			int temp2 = pong->GetP2Score();

			fout.write((char *)&temp1,sizeof(int));
			fout.write((char *)&temp2,sizeof(int));
			fout.write((char *)&pong->AIEnabled,sizeof(bool));


			fout.close();
		}

			 //Set the main window title
			SetWindowTitle(hWnd, &ofn.lpstrFile[ofn.nFileOffset]);
	
	}

	bPaused = false;
}

void OnFileClose(HWND hWnd)
{
	if(ClearDocument(hWnd))
	{
		PostMessage(hWnd, WM_CLOSE, 0, 0);
	}

}
